-------------------------------- MODULE Sem --------------------------------
EXTENDS Integers

CONSTANT N
ASSUME N \in Nat

Procs == 0..N


(*******
--algorithm SemMutex {
   variable sem = 1 ;
   fair process (P \in Procs) {
     ncs:- while (TRUE) {
             skip ;
\*     enter:+ await sem = 1 ;
\*             sem := 0 ;
        enter:+ if (sem = 1) {
                  sem := 0 ;
                  goto cs 
                } 
                else {
                  goto enter
                } ;

         cs: skip ;
       exit: sem := 1 ;
           }
   }
}
*******)
\* BEGIN TRANSLATION (chksum(pcal) = "d43d362d" /\ chksum(tla) = "8dfff25d")
VARIABLES sem, pc

vars == << sem, pc >>

ProcSet == (Procs)

Init == (* Global variables *)
        /\ sem = 1
        /\ pc = [self \in ProcSet |-> "ncs"]

ncs(self) == /\ pc[self] = "ncs"
             /\ TRUE
             /\ pc' = [pc EXCEPT ![self] = "enter"]
             /\ sem' = sem

enter(self) == /\ pc[self] = "enter"
               /\ IF sem = 1
                     THEN /\ sem' = 0
                          /\ pc' = [pc EXCEPT ![self] = "cs"]
                     ELSE /\ pc' = [pc EXCEPT ![self] = "enter"]
                          /\ sem' = sem

cs(self) == /\ pc[self] = "cs"
            /\ TRUE
            /\ pc' = [pc EXCEPT ![self] = "exit"]
            /\ sem' = sem

exit(self) == /\ pc[self] = "exit"
              /\ sem' = 1
              /\ pc' = [pc EXCEPT ![self] = "ncs"]

P(self) == ncs(self) \/ enter(self) \/ cs(self) \/ exit(self)

Next == (\E self \in Procs: P(self))

Spec == /\ Init /\ [][Next]_vars
        /\ \A self \in Procs : WF_vars((pc[self] # "ncs") /\ P(self)) /\ SF_vars(enter(self))

\* END TRANSLATION 

--------

ME == INSTANCE MutualExclusionSpec WITH
                pc <- [proc \in Procs  |->  CASE pc[proc] = "cs"            ->  "cs"
                                              [] pc[proc] \in {"enter"}     ->  "csentry"
                                              [] OTHER                      ->  "non-cs"]

THEOREM Spec => ME!Spec
THEOREM Spec => []ME!MutualExclusion
THEOREM Spec => ME!Liveness

=============================================================================
